package letreiro;

import java.util.Properties;

import org.omg.CORBA.ORB;
import org.omg.CosNaming.NameComponent;
import org.omg.CosNaming.NamingContext;
import org.omg.CosNaming.NamingContextHelper;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.POAHelper;


/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */
public class LetreiroImpl extends LetreiroPOA implements Runnable {

    private FrameLetreiro letreiro;

    // Controle do LetreiroImpl
    private String texto = "texto";
	private int posicao = 0;
	private String temp = "                         ";
	private String id;
	private int vel;

    // Controle da Thread
    private boolean sair;
    private Thread thread;

    // ---------------------------------------------------------------------

	public LetreiroImpl(String id) {
        this.id = id;
		try {
            letreiro = new FrameLetreiro();
			thread = new Thread(this);
			update("Teste de Sistemas Distribudos", 200);
            thread.setDaemon(true);
			thread.start();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

    /**
     *
     * @see java.lang.Runnable#run()
     */
    public void run() {

        try {
            sair = false;
            while (!sair) {
                temp = temp.substring(1) + texto.charAt(posicao);
                letreiro.setTexto(temp);
                posicao = (posicao + 1) % texto.length();
                Thread.sleep(vel);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    /**
     * Fecha o outdoor.
     *
     * @param sair The sair to set
     */
    public void sair() {
        this.sair = true;
        letreiro.dispose();
    }

    // ---------------------------------------------------------------------

	public boolean update(String texto, int vel) {
		if (texto.length() < 18) {
			for (int i = texto.length(); i < 20; i++)
				texto += " ";
		} else {
			texto += "  ";
		}
		this.texto = texto;
        letreiro.setTexto(texto);
		this.vel = vel;
		this.temp = "                         ";
		this.posicao = 0;
        return true;
	}

    public String getTexto() {
        return texto.trim();
    }

    public int getTempo() {
        return vel;
    }

    public String getId() {
        return id;
    }

    public static void main(String[] args) {
        try {

            String id = args[0];
            System.out.println(id);

            Properties props = System.getProperties();
            ORB orb = ORB.init(args, props);

            /* Obtem referencia para o POA */
            org.omg.CORBA.Object obj =
                orb.resolve_initial_references("RootPOA");
            POA poa = POAHelper.narrow(obj);

            /* Obtem referencia para o servidor de nomes */
            obj = orb.resolve_initial_references("NameService");
            NamingContext namingContext = NamingContextHelper.narrow(obj);

            LetreiroImpl letreiroImpl = new LetreiroImpl(id);
            Letreiro letreiro = letreiroImpl._this(orb);

            /* Registra-se no servidor de nomes */
            NameComponent[] name = new NameComponent[1];
            name[0] = new NameComponent(id, "");

            namingContext.rebind(name, letreiro);
            poa.the_POAManager().activate();

            orb.run();
        } catch (Exception ex) {
            ex.printStackTrace();
            System.exit(1);
        }
    }

}